// Rotator  an Illustrator script for Scriptographer 
// 
// Rotate selected items about chosen point
// ruler origin; centre of artboard; centre of selection; specified x/y
// Shift clicking with the scriptographer tool sets the rotation point 
// dragging sets the rotation about the rotation point. 
//
// gw@westdale.demon.co.uk
//


// Interface ---------------------------

var useAB = 'Artboard'
var useRuler = 'Ruler'
var useXY = 'x y'
var useCentre = 'selection centre'

var centre = new Point();

var values = {
    useOrigin: useCentre,
    deg: 45,
    x: 0,
    y: 0,
    reverse:false
};

var components = {

    useOrigin: { 
        type:  'list',
        label: 'Usage',
        options: [useAB, useRuler, useCentre, useXY]
    },
    x: {
    label:'x', 
    type: 'number'
    },  
    y: {
    label:'y', 
    type: 'number'
    },
    deg: {
    label:'degrees', 
    type: 'number'
    },
    reverse: {
    label: 'reverse',
    type : 'checkbox',
    value: false
    },
    Run: { 
        type: 'button',
        value:'Run',
        label:'Rotate',
        onClick: function() { Run(); }
    },
    ruler4: {
        type: 'ruler'
    },
    text1: {
    type: 'text',
    value:'shift-click script tool sets x/y'
    
    },
    text2: {
    type: 'text',
    value:'script tool drag sets \nrotate angle about x/y'
    }
};

// reload paramaters if set 
if (script.preferences.x) { values.x = script.preferences.x};
if (script.preferences.y) { values.y = script.preferences.y};
if (script.preferences.deg) { values.deg = script.preferences.deg};
if (script.preferences.reverse) { values.reverse = script.preferences.reverse};
if (script.preferences.useOrigin) { values.useOrigin = script.preferences.useOrigin};

var palette = new Palette('Rotator', components, values);


// ---------------------------------------------------------

function Run() {

   var paths = document.getItems({ type: Path, selected: true });
   
   if (paths.length) {    
      RotateThem(paths);      
   }else{ 
      Dialog.alert('Please select one or more items first.');   
   }
 
 // save for next time
 script.preferences.x = values.x ;
 script.preferences.y = values.y;
 script.preferences.deg = values.deg;
 script.preferences.reverse = values.reverse ;
 script.preferences.useOrigin = values.useOrigin;
   
} // fn Run ---------------------------------------------


function RotateThem(paths) {

    var deg = values.deg;

    CalcCentre(paths);
     
    if (values.reverse) { deg = - deg };
      
    for ( var p = 0; p < paths.length; p++) {
       paths[p].rotate(deg, centre);
    }
 

} // fn RotateThem -------------------------------------------


function CalcCentre(paths) {   // set values.x and y
   centre = new Point(0,0)
   var usage = values.useOrigin 
   
    if (usage == useCentre) {
    
        // average of all item centres
        for ( var p = 0; p < paths.length; p++) {
           centre = centre + paths[p].bounds.center;
        }
        centre = centre / paths.length;
    
    }else if (usage == useRuler) { 
      centre = document.rulerOrigin;
      
    }else if (usage == useAB) { 
      centre = document.activeArtboard.bounds.center; 
    
    }else{ 
       centre.x = values.x;
       centre.y = values.y;
    }  


} // fn CalcCentreSelection ----------------------------------



// pen events ------------------------------------------------ 

function onMouseDown(event) { 

    if (Key.isDown('shift')) {
        rotapoint = event.point;
        values.x = rotapoint.x;
        values.y = rotapoint.y;
        values.useOrigin = useXY;
    }
    //else ignore
} 
 
 
 
function onMouseUp(event) { 
    if  ( Key.isDown('shift')) {  
        // ignore up event
        
    } else {
    
        if (event.point == event.downPoint) {
            // dont calculate angle when at same point
               
        } else {
            // work out rotation angle ...
            var rotapoint = new Point(values.x, values.y);
            var vector1 = event.downPoint - rotapoint;
            var vector2 = event.point - rotapoint;
            var rotangle = vector2.angle - vector1.angle;
            values.deg = rotangle;
        }
    }
}